#version 430 core

layout(location = 0) out vec4 color_output;

in vec3 v_normal;
in vec2 v_uv0;
in vec3 v_fragment_position_in_world;

uniform vec3 u_CameraPositionInWorld;

//uniform mat3 NormalWorldFromModel;


#define pi 3.1415926535897932384626433832795

%%PublicCode%%


void main()
{
	vec2 uv0 = v_uv0;
	
	vec4 shader_color= vec4(0.6, 0.6, 0.6, 1.0);
	vec3 shader_normal = normalize(v_normal);
	
	%%MainCode%%
	
	vec3 ViewDir = normalize(u_CameraPositionInWorld-v_fragment_position_in_world);
	
	vec4 MaterialColor = shader_color;
	
	//alpha Test:
	//if(MaterialColor.a<0.2)
	//	discard;
	//MaterialColor.a = 1;
	
	//vec3 TransformedNormal = normalize(NormalWorldFromModel*shader_normal);
	
		
	color_output = MaterialColor;
}