#version 430 core

out vec3 v_normal;
out vec3 v_fragment_position_in_world;

uniform mat4 u_WorldFromModel;
uniform mat4 u_CameraFromWorld;
uniform mat4 u_ScreenFromCamera;

%%PublicCode%%

void main()
{
	vec4 vertex_position;
	vec3 vertex_normal;
	
	mat4 WorldFromModel = u_WorldFromModel; 
	%%MainCode%%
	
	v_normal = vertex_normal;
	
	v_fragment_position_in_world = (WorldFromModel * vertex_position).xyz;
	
	gl_Position = u_ScreenFromCamera * u_CameraFromWorld * WorldFromModel * vertex_position;
}